# use strict;use warnings; 

-d 'plugins' or mkdir('plugins',0777) or die('can not mkdir plugins directory');

my $safemode=( $main::form{a} && $main::form{a} =~ /^pluginmgr/ );

###
### Create link to pluginmgr
###

$main::inline_plugin{'a_pluginmgr'} = sub {
    &main::anchor( 'Plugin Manager' , { a=>'pluginmgr' } );
};

###
### create plugin list
### 

my @plugins;
local *DIR;
opendir(DIR,'plugins');
foreach my $fn ( sort readdir(DIR) ){
    if( $fn =~ /^([0-9a-f][0-9a-f])+$/ ){
        my $name=pack('h*',$fn);
        push( @plugins,[ $fn , $name ] );

        if( !$safemode && $main::config{"pluginmgr__${fn}"} ){
            do "plugins/$fn"; $@ and die($@);
        }
    }
}
closedir(DIR);

###
### Plugin Uploader
###

$main::action_plugin{'pluginmgr_upload'} = sub{
    &main::ninsho;
    my $name=$main::form{'plugin.filename'};
    my $body=$main::form{'plugin'};
    my $fname=unpack('h*',$name);
    local *FP;
    open(FP,'>plugins/'.$fname) or die;
        print FP $body;
    close(FP);
    &main::transfer_url( &main::myurl( { a=>'pluginmgr' } ));
};

###
### Plugin Enable/Disabler
###

$main::action_plugin{'pluginmgr_permit'} = sub {
    &main::ninsho;
    foreach my $key (grep(/^pluginmgr__/,keys %::config)){
        delete $::config{$key};
    }
    while( my ($key,$value)=each %::form ){
        $::config{$key} = $value if $key =~ /^pluginmgr__/;
    }
    &main::save_config;
    &main::transfer_url( &main::myurl( { a=>'pluginmgr' } ));
};

###
### Plugin Eraser
###
$main::action_plugin{'pluginmgr_erase'} = sub {
    &main::ninsho;
    my $fn=$main::form{target};
    $fn =~ /^([0-9a-f][0-9a-f])+$/ or die("!Invalied plugin-filename $fn!");
    -f "./plugins/$fn" or die('!Remove not exists plugin!');
    unlink "./plugins/$fn";
    &main::transfer_url( &main::myurl( { a=>'pluginmgr' } ));
};

###
### Plugin Manager Menu
###

$main::action_plugin{'pluginmgr'} = sub {
    &print_header( divclass=>'max' , title=>'Upload Plugin' );
    &putenc(<<HTML
<h1>Plugin Manager</h1>
<div class="day">
<h2>Enable/Disable Plugin</h2>
<div class="body">
<form name="plugin_form" action="%s" method="post" accept-charset="%s" >
HTML
    , $::postme , $::charset );
    foreach my $p (@plugins){
        &putenc('<input type="checkbox" name="pluginmgr__%s" value="1"%s> %s<br>'
            , $p->[0]
            , $::config{"pluginmgr__".$p->[0]} ? ' checked':''
            , $p->[1] );
    }
    &putenc(<<HTML
<p>
Sign: <input type="password" name="password">
<input type="hidden" name="a" value="pluginmgr_permit">
<input type="submit" value="Submit">
</p>
</form>
</div><!-- body -->
</div><!-- day -->
<div class="day">
<h2>New plugin</h2>
<div class="body">
<form name="plugin_form" action="%s" enctype="multipart/form-data"
 method="post" accept-charset="%s" >
Plugin file: <input type="file" name="plugin" size="48">
<p>Sign: <input type="password" name="password"
><input type="hidden" name="a" value="pluginmgr_upload"
><input type="submit" value="Submit">
</p>
</form>
</div><!-- body -->
</div><!-- day -->
<div class="day">
<h2>Erase unused Plugins</h2>
<div class="body">
<form action="%s" method="post" accept-charset="%s">
<p>Erase all plugins unused.</p>
HTML
    , $main::me , $main::charset 
    , $main::me , $main::charset 
    );

    foreach my $p (@plugins){
        unless( $::config{"pluginmgr__".$p->[0]} ){
            &putenc('<input type="radio" name="target" value="%s"> %s<br>'
                , $p->[0]
                , $p->[1] );
        }
    }

    &putenc(<<HTML
<p>Sign: <input type="password" name="password"
><input type="hidden" name="a" value="pluginmgr_erase"
><input type="submit" value="Submit">
</p>
</form>
</div><!-- body -->
</div><!-- day -->
HTML
    );
    &print_footer;
};
1;

